
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "header.h"

void pinvr(int c) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   block-diagonal matrix-vector multiplication                       
//---------------------------------------------------------------------

       int i, j, k;
       double r1, r2, r3, r4, r5, t1, t2;

//---------------------------------------------------------------------
//      treat only one cell                                   
//---------------------------------------------------------------------
       for (k = start(3,c); k <= cell_size(3,c)-end(3,c)-1; k++) {
          for (j = start(2,c); j <= cell_size(2,c)-end(2,c)-1; j++) {
             for (i = start(1,c); i <= cell_size(1,c)-end(1,c)-1; i++) {

                r1 = rhs(i,j,k,1,c);
                r2 = rhs(i,j,k,2,c);
                r3 = rhs(i,j,k,3,c);
                r4 = rhs(i,j,k,4,c);
                r5 = rhs(i,j,k,5,c);

                t1 = bt * r1;
                t2 = 0.5e0 * ( r4 + r5 );

                rhs(i,j,k,1,c) =  bt * ( r4 - r5 );
                rhs(i,j,k,2,c) = -r3;
                rhs(i,j,k,3,c) =  r2;
                rhs(i,j,k,4,c) = -t1 + t2;
                rhs(i,j,k,5,c) =  t1 + t2;
             }
          }
       }

       return;
}



