#include <stdio.h>
#include <upc.h>

#ifndef __UPC__
#define MYTHREAD 0
#define THREADS 1
#endif

shared [*] int x[THREADS];

int main(int argc, char** argv)
{
  if (MYTHREAD == 0) printf("hello world\n"); 
  printf("I am thread number %d of %d threads\n", MYTHREAD, THREADS);

  x[MYTHREAD] = MYTHREAD + 1;
  upc_barrier;
  if (MYTHREAD > 0) {
     printf("x from 0 is %i\n",x[0]);
//  expected value 1 from thread 0 will be printed out on all other threads
  }
  return 0;
}
