
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"
#include "upcnpb.h"

void exchange_5(double g[],int ibeg,int ifin1) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   compute the right hand side based on exact solution
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  input parameters
//---------------------------------------------------------------------
#define g(i,j) g[(i)+(ISIZ2+2)*(j)]

//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int k;

      int ptr;



//---------------------------------------------------------------------
//   communicate in the south and north directions
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   send north
//---------------------------------------------------------------------
      if (ibeg==1) {
        ptr = wptr(3);
        ll_buffer = (double *)&u_buffer(node,ptr);
        ptr = 0;
        for (k = 1; k <= nz; k++) {
          ll_buffer(ptr + k) = g(1,k);
        }

      }

      upc_barrier;

//---------------------------------------------------------------------
//   receive from south
//---------------------------------------------------------------------
      if (ifin1==nx) {

        ptr = wptr(3);
        upc_memget(ul_buffer, &u_buffer(south,ptr),
                   sizeof(double)*nz);
        ptr = 0;
        for (k = 1; k <= nz; k++) {
          g(nx+1,k) = ul_buffer(ptr + k);
        }

      }


      return;
#undef g
}
