module mod_reduction
  implicit none
  private
  public :: caf_reduce, caf_prefix_reduce
  integer, parameter :: dk = kind(1.0d0)
  abstract interface
     real(dk) function rf(a, b)
        import :: dk
        real(dk), intent(in) :: a, b
     end function
  end interface
contains
  real(kind=dk) function caf_reduce(x, ufun)
    real(kind=dk), intent(in) :: x
    procedure(rf) :: ufun
  end function caf_reduce
  real(kind=dk) function caf_prefix_reduce(x, ufun)
    real(kind=dk), intent(in) :: x
    procedure(rf) :: ufun
  end function caf_prefix_reduce
end module
